﻿using System;
using System.Collections.Generic;
using Microsoft.ServiceBus.Messaging;

namespace Nardax.Azure.ServiceBus
{
    public interface ISubscriptionAdapter : ISubscriptionAdapter<BrokeredMessage>
    { }

    public interface ISubscriptionAdapter<T>
    {
        void Initialize();

        IEnumerable<T> GetConsumingEnumerable();

        void StopReceiving();

        void Close();

        event EventHandler<ReceiveFailedEventArgs> ReceiveFailed;

        SubscriptionAdapterDescription<T> SubscriptionAdapterDescription { get; }
    }
}