﻿using Microsoft.ServiceBus.Messaging;
using System;

namespace Nardax.Azure.ServiceBus
{
    public class SubscriptionAdapterDescription : SubscriptionAdapterDescription<BrokeredMessage>
    {
        public SubscriptionAdapterDescription()
        {
            BrokeredMessageContainerFactory = new BrokeredMessageContainerFactory();
        }
    }

    public class SubscriptionAdapterDescription<T>
    {
        public SubscriptionAdapterDescription()
        {
            PrefetchCount = 0;
            ServerWaitTime = TimeSpan.Zero;
            MaxDeliveryCount = int.MaxValue;
        }

        public string[] ConnectionStrings { get; set; }

        public TopicDescription TopicDescription { get; set; }

        public SubscriptionDescription SubscriptionDescription { get; set; }

        public IRetryPolicy RetryPolicy { get; set; }

        public RuleDescription RuleDescription { get; set; }

        public IBrokeredMessageContainerFactory<T> BrokeredMessageContainerFactory { get; set; }

        public int PrefetchCount { get; set; }

        public TimeSpan ServerWaitTime { get; set; }

        public int MaxDeliveryCount { get; set; }
    }
}