﻿using System;
using Microsoft.WindowsAzure;
using Nardax.Azure.StorageClient;

namespace Nardax.Azure
{
    public interface ICloudStorageAccount
    {
        ICloudBlobClient CreateCloudBlobClient();

        ICloudQueueClient CreateCloudQueueClient();

        ICloudTableClient CreateCloudTableClient();

        Uri BlobEndpoint { get; }

        StorageCredentials Credentials { get; }
        
        Uri QueueEndpoint { get; }

        Uri TableEndpoint { get; }

        string ToString(bool exportSecrets);
    }
}
