﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Nardax.Diagnostics;
using System.Diagnostics;

namespace Nardax.ServiceModel.Discovery
{
    public class DiscoveryTraceSource : TraceSourceWrapper
    {
        private const string TRACE_SOURCE_NAME = "Nardax.ServiceModel.Discovery";

        private static ITraceSource _instance;
        private static object _lock = new object();

        private DiscoveryTraceSource()
        {
            TraceSource = new TraceSource(TRACE_SOURCE_NAME);
        }

        public static ITraceSource Instance
        {
            get
            {
                if (_instance == null)
                {
                    lock (_lock)
                    {
                        if (_instance == null)
                        {
                            _instance = new DiscoveryTraceSource();
                        }
                    }
                }

                return _instance;
            }
        }
    }
}