﻿using System;
using System.Diagnostics;

namespace Nardax
{
    public interface IRetryPolicy
    {
        void Execute(Action method);

        void Execute(Action method, Stopwatch stopwatch);

        void Execute(Action method, Action<int, Exception, TimeSpan> onRetry);

        void Execute(Action method, Stopwatch stopwatch, Action<int, Exception, TimeSpan> onRetry);

        TResult Execute<TResult>(Func<TResult> method);

        TResult Execute<TResult>(Func<TResult> method, Stopwatch stopwatch);

        TResult Execute<TResult>(Func<TResult> method, Action<int, Exception, TimeSpan> onRetry);

        TResult Execute<TResult>(Func<TResult> method, Stopwatch stopwatch, Action<int, Exception, TimeSpan> onRetry);

        event EventHandler<RetryingEventArgs> Retrying;

        ITransientErrorDetectionStrategy TransientErrorDetectionStrategy { get; }

        IRetryStrategy RetryStrategy { get; }
    }
}