﻿using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Nardax.ServiceModel.Discovery.Tests
{
    [TestClass]
    public class StringExtensionsTests
    {
        [TestMethod]
        public void BegingOfStringIsMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "/a/1";

            Assert.IsTrue(s.MatchByPair(value));
        }

        [TestMethod]
        public void BegingOfStringIsNotMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "/a/2/b/2";

            Assert.IsFalse(s.MatchByPair(value));
        }

        [TestMethod]
        public void EndOfStringIsMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "/d/4";

            Assert.IsTrue(s.MatchByPair(value));
        }

        [TestMethod]
        public void MiddleOfStringIsMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "/c/3";

            Assert.IsTrue(s.MatchByPair(value));
        }

        [TestMethod]
        public void BeginingAndEndOfStringIsMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "a/1/d/4";

            Assert.IsTrue(s.MatchByPair(value));
        }

        [TestMethod]
        public void WrongValueIsNotMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "c/1.2";

            Assert.IsFalse(s.MatchByPair(value));
        }

        [TestMethod]
        public void OneRightValueOneWrongValueIsNotMatch()
        {
            var s = "/a/1/b/2/c/3/d/4";
            var value = "b/2/c/1.2";

            Assert.IsFalse(s.MatchByPair(value));
        }
    }
}
