﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Nardax.Tests
{
	[TestClass]
	public class DateTimeExtensionsTests
	{
		private DateTime _date;

		[TestInitialize]
		public void TestInitialize()
		{
			_date = new DateTime(1974, 7, 3);	
		}

		[TestMethod]
		public void Min_DateLessThanValue_ReturnsDate()
		{
			var result = _date.Min(DateTime.MaxValue);
			
			Assert.AreEqual(_date, result);
		}

		[TestMethod]
		public void Min_DateEqualsValue_ReturnsDate()
		{
			var date2 = new DateTime(1974, 7, 3);	

			var result = _date.Min(date2);

			Assert.AreEqual(_date, result);
		}

		[TestMethod]
		public void Min_DateGreaterThanValue_ReturnsValue()
		{
			var value = new DateTime(1974, 4, 7);

			var result = _date.Min(value);

			Assert.AreEqual(value, result);
		}

		[TestMethod]
		public void Max_DateLessThanValue_ReturnsValue()
		{
			var value = new DateTime(1994, 9, 6);

			var result = _date.Max(value);

			Assert.AreEqual(value, result);
		}

		[TestMethod]
		public void Max_DateEqualsValue_ReturnsDate()
		{
			var date2 = new DateTime(1974, 7, 3);

			var result = _date.Max(date2);

			Assert.AreEqual(_date, result);
		}

		[TestMethod]
		public void Max_DateGreaterThanValue_ReturnsDate()
		{
			var result = _date.Max(DateTime.MinValue);

			Assert.AreEqual(_date, result);
		}
	}
}
